import { RouteChildrenProps } from 'react-router';
import { LocationDescriptorObject } from 'history';
import { NamedRouteConfig } from './NamedRouter';
export interface ExtendedRouteConfig extends NamedRouteConfig {
    parents: string[];
    regex?: RegExp;
}
declare type RouteChildrenPropsWithLocation = Omit<Partial<RouteChildrenProps<any, any>>, 'location'> & {
    location: RouteChildrenProps<any, any>['location'];
};
export declare const buildRoutePath: (map: Map<string, ExtendedRouteConfig>, name: string, params?: any) => string;
export declare const mapRoutes: (routes: NamedRouteConfig<{
    [key: string]: any;
}>[], basename?: string, parents?: string[], map?: Map<string, ExtendedRouteConfig>) => Map<string, ExtendedRouteConfig>;
export declare type NamedLocation = Omit<LocationDescriptorObject, 'pathname'> & {
    name: string;
};
export declare class RoutingContext {
    protected readonly routesMap: Map<string, ExtendedRouteConfig>;
    protected routerContext: RouteChildrenPropsWithLocation;
    readonly location: import("history").Location<any>;
    readonly history: import("history").History<any>;
    readonly params: {
        [key: string]: string;
    };
    readonly currentRoute: ExtendedRouteConfig | null;
    constructor(routesMap: Map<string, ExtendedRouteConfig>, routerContext: RouteChildrenPropsWithLocation);
    match: (pathname: string, matchAll?: boolean | undefined) => ExtendedRouteConfig | null;
    getPath: <TParams>(name: string, params?: TParams | undefined) => string;
    getRawPath: (name: string) => string | (string[] & string);
    getRoute: (name: string) => ExtendedRouteConfig;
    push: (location: string | NamedLocation, params?: {
        [key: string]: string;
    } | undefined) => void;
    replace: (location: string | NamedLocation, params?: {
        [key: string]: string;
    } | undefined) => void;
}
export declare type RoutingContextArg = Omit<Partial<RouteChildrenProps<any, any>>, 'location'> & {
    location: string | RouteChildrenProps<any, any>['location'];
};
export declare const buildRoutingContext: (routes: NamedRouteConfig<{
    [key: string]: any;
}>[], routerContext: RoutingContextArg, basename?: string | undefined) => RoutingContext;
export {};
