"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const hooks_1 = require("./hooks");
function withNamedRouting(Component) {
    const namedRouting = hooks_1.useNamedRouting();
    const WrappedComponent = (props) => (react_1.default.createElement(Component, Object.assign({}, props, { namedRouting: namedRouting })));
    WrappedComponent.displayName = `WithRouting(${Component.displayName || Component.name})`;
    return WrappedComponent;
}
exports.withNamedRouting = withNamedRouting;
